VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Welcome"
   ClientHeight    =   5325
   ClientLeft      =   1830
   ClientTop       =   2025
   ClientWidth     =   7530
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   355
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   502
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Dx As New DirectX7
Dim Dd As DirectDraw4
Dim clip As DirectDrawClipper
Dim d3drm As Direct3DRM3
Dim scene As Direct3DRMFrame3
Dim cam As Direct3DRMFrame3
Dim dev As Direct3DRMDevice3
Dim view As Direct3DRMViewport2
Dim mesh As Direct3DRMMeshBuilder3
Dim XFileTex As Direct3DRMTexture3
Dim LightFrame As Direct3DRMFrame3
Dim ViewFrame(13, 23) As Direct3DRMFrame3
Dim Wall As Direct3DRMMeshBuilder3
Dim TCase As Integer
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Private Sub Form_Load()
TCase = 10
Const Sin5 = 8.715574E-02!
Const Cos5 = 0.9961947!
    
    Set Dd = Dx.DirectDraw4Create("")
    Set clip = Dd.CreateClipper(0)
    clip.SetHWnd Me.hWnd
    
    Dd.SetDisplayMode 800, 600, 32, 0, DDSDM_DEFAULT
    
    Set d3drm = Dx.Direct3DRMCreate()
    Set scene = d3drm.CreateFrame(Nothing)
    Set cam = d3drm.CreateFrame(scene)
    cam.SetPosition scene, 10, 5, 30
    
    Dim light As Direct3DRMLight
    Set light = d3drm.CreateLightRGB(D3DRMLIGHT_POINT, 0.55, 0.55, 0.55)
    light.SetUmbra 0.8: light.SetPenumbra 1.1
    Set LightFrame = d3drm.CreateFrame(scene)
    LightFrame.SetPosition Nothing, 0, 10, 0
    LightFrame.AddLight light
    
        scene.AddLight d3drm.CreateLightRGB(D3DRMLIGHT_AMBIENT, 0.65, 0.65, 0.65)
    
    Set dev = d3drm.CreateDeviceFromClipper(clip, "IID_IDirect3DRGBDevice", Me.ScaleWidth, Me.ScaleHeight)
        
    dev.SetQuality D3DRMFILL_SOLID + D3DRMLIGHT_ON + D3DRMSHADE_GOURAUD
    dev.SetDither D_TRUE
    Set view = d3drm.CreateViewport(dev, cam, 0, 0, Me.ScaleWidth, Me.ScaleHeight)
    view.SetBack 3000!
    
    Set mesh = d3drm.CreateMeshBuilder()
    mesh.SetPerspective D_TRUE
    scene.AddVisual mesh
    
    
    Set Wall = Charge_X("blue.x")
    
    
    Dim i%, j%
    For i% = 0 To 13
        For j% = 0 To 23
            
            Set ViewFrame(i%, j%) = d3drm.CreateFrame(scene)
             ViewFrame(i%, j%).SetPosition scene, i% * TCase, 0, j% * TCase
        Next j%
    Next i%
    
    Dim Carte$
    Carte$ = "X...X.X.....RXY***Y****Y"
        For i% = 0 To 0
        For j% = 0 To 0
            With ViewFrame(i%, j%)
                Select Case Mid$(Carte$, j% + 1, 1)
                Case "X"
                    Call .AddVisual(Wall)
                End Select
            End With
       Next j%
    Next i%
    
    Me.Show
    Me.Refresh
    DoEvents
        
    Do While DoEvents()
 
If GetKeyState(vbKeyDown) < -1 Then cam.SetPosition cam, 0, 0, -1
If GetKeyState(vbKeyUp) < -1 Then cam.SetPosition cam, 0, 0, 1

view.Clear D3DRMCLEAR_ALL
        view.Render scene
        dev.Update
        
    Loop
    
End Sub
Private Function Charge_X(Nom$) As Direct3DRMMeshBuilder3
    Set Charge_X = d3drm.CreateMeshBuilder()
    Charge_X.LoadFromFile Nom$, 0, D3DRMLOAD_FROMFILE, Nothing, Nothing
End Function
